精华内容
下载资源
问答
  • python程序异常处理

    2020-05-28 17:33:35
    python使用try-except语句实现异常处理,其基本语法格式: try: <语句块1> except <异常类型>: <语句块2> 为上述小程序增加异常处理: try: num = eval(input("请输入一个整数:")) print(num...

    1、异常处理:try-except语句

    在这里插入图片描述
    在这里插入图片描述
    python异常信息中最重要的部分是异常类型,它表明发生异常原因,也是程序处理异常的依据。
    python使用try-except语句实现异常处理,其基本语法格式:

    try:
       <语句块1>
    except <异常类型>:
       <语句块2>
    

    为上述小程序增加异常处理:

    try:
        num = eval(input("请输入一个整数:"))
        print(num**2)
    except NameError:
        print("输入错误,请输入一个整数!")
    

    结果为:

    =
    请输入一个整数:NO
    输入错误,请输入一个整数!
    >>> 
    

    2、异常和错误
    编程语言的异常和错误是两个相似但不同的概念。
    异常(checked exception):可以预见的例外情况,例如程序期望获得数字输入却得到了其他字符输入、打开一个不存在的文件等。
    错误(unchecked exception):一些因为程序编码逻辑产生的不可预见的例外情况,错误发生后程序无法恢复执行。
    3、异常的高级用法
    try-except语句可以支持多个except语句,语法格式如下:

    try:
        <语句块1>
    except <异常类型1>:
        <语句块2>
    ...
    except <异常类型N>:
        <语句块N+1>
    except:
        <语句块N+2>
    
      其中,第1到第N个except语句后面都指定了异常类型,说明这些except所包含的语句块只处理这些类型的异常。最后一个except语句没有指定任何类型,表示它所对应的语句块可以处理所有其他异常。
    

    除了try和except保留字外,异常语句还可以与else和finally保留字配合使用,语法格式如下 :

    try:                   #放置最想要检测的部分
        <语句块1>
    except <异常类型1>:     #放置想要捕获的异常,以及出现异常后的处理
        <语句块2>
    else:                   #放置不出现异常时要执行的部分
        <语句块3>
    finally:                #放置无论如何都要执行的部分
        <语句块4>
    

    实例:

    try:
        alp = "ABCDEFGHIJKLMNOPQRSUVWXYZ"
        idx = eval(input("请输入一个整数:"))
        print(alp[idx])
    except NameError:
        print("输入错误,请输入一个整数!")
    else:
        print("没有发生异常。")
    finally:
        print("程序执行完毕。")
    

    结果为:

    =
    请输入一个整数:5
    F
    没有发生异常。
    程序执行完毕。
    >>> 
    =============== RESTART: F:/软件/python/练习1/text4/try-except.py ===============
    请输入一个整数:NO
    输入错误,请输入一个整数!
    程序执行完毕。
    >>> 
    

    总结:
    python能识别多种异常类型,但不建议编写程序时过度依赖try-except这种异常处理机制。try-except异常一般只用来检测极少发生的情况,例如,用户输入的合规性或文件打开是否成功等。面对商业应用的软件产品,稳定性和可靠性是最重要的衡量指标之一。即使这类产品也不会滥用try-except类型语句。因为采用try-except语句会影响代码的可读性,增加代码维护难度,因此,一般只在关键地方采用try-except类型的语句处理可能发生的异常。

    展开全文
  • python异常处理

    万次阅读 2018-08-10 22:22:36
    Python 异常处理 python提供了两个非常重要的功能来处理python程序在运行中出现的异常和错误。你可以使用该功能来调试python程序异常处理: 本站Python教程会具体介绍。 断言(Assertions):本站Python教程会具体...

    Python 异常处理

    python提供了两个非常重要的功能来处理python程序在运行中出现的异常和错误。你可以使用该功能来调试python程序。

    • 异常处理: 本站Python教程会具体介绍。
    • 断言(Assertions):本站Python教程会具体介绍。

    python标准异常

    异常名称 描述
    BaseException 所有异常的基类
    SystemExit 解释器请求退出
    KeyboardInterrupt 用户中断执行(通常是输入^C)
    Exception 常规错误的基类
    StopIteration 迭代器没有更多的值
    GeneratorExit 生成器(generator)发生异常来通知退出
    StandardError 所有的内建标准异常的基类
    ArithmeticError 所有数值计算错误的基类
    FloatingPointError 浮点计算错误
    OverflowError 数值运算超出最大限制
    ZeroDivisionError 除(或取模)零 (所有数据类型)
    AssertionError 断言语句失败
    AttributeError 对象没有这个属性
    EOFError 没有内建输入,到达EOF 标记
    EnvironmentError 操作系统错误的基类
    IOError 输入/输出操作失败
    OSError 操作系统错误
    WindowsError 系统调用失败
    ImportError 导入模块/对象失败
    LookupError 无效数据查询的基类
    IndexError 序列中没有此索引(index)
    KeyError 映射中没有这个键
    MemoryError 内存溢出错误(对于Python 解释器不是致命的)
    NameError 未声明/初始化对象 (没有属性)
    UnboundLocalError 访问未初始化的本地变量
    ReferenceError 弱引用(Weak reference)试图访问已经垃圾回收了的对象
    RuntimeError 一般的运行时错误
    NotImplementedError 尚未实现的方法
    SyntaxError Python 语法错误
    IndentationError 缩进错误
    TabError Tab 和空格混用
    SystemError 一般的解释器系统错误
    TypeError 对类型无效的操作
    ValueError 传入无效的参数
    UnicodeError Unicode 相关的错误
    UnicodeDecodeError Unicode 解码时的错误
    UnicodeEncodeError Unicode 编码时错误
    UnicodeTranslateError Unicode 转换时错误
    Warning 警告的基类
    DeprecationWarning 关于被弃用的特征的警告
    FutureWarning 关于构造将来语义会有改变的警告
    OverflowWarning 旧的关于自动提升为长整型(long)的警告
    PendingDeprecationWarning 关于特性将会被废弃的警告
    RuntimeWarning 可疑的运行时行为(runtime behavior)的警告
    SyntaxWarning 可疑的语法的警告
    UserWarning 用户代码生成的警告

    什么是异常?

    异常即是一个事件,该事件会在程序执行过程中发生,影响了程序的正常执行。

    一般情况下,在Python无法正常处理程序时就会发生一个异常。

    异常是Python对象,表示一个错误。

    当Python脚本发生异常时我们需要捕获处理它,否则程序会终止执行。


    异常处理

    捕捉异常可以使用try/except语句。

    try/except语句用来检测try语句块中的错误,从而让except语句捕获异常信息并处理。

    如果你不想在异常发生时结束你的程序,只需在try里捕获它。

    语法:

    以下为简单的try....except...else的语法:

    try:
    <语句>        #运行别的代码
    except <名字>:
    <语句>        #如果在try部份引发了'name'异常
    except <名字>,<数据>:
    <语句>        #如果引发了'name'异常,获得附加的数据
    else:
    <语句>        #如果没有异常发生

    try的工作原理是,当开始一个try语句后,python就在当前程序的上下文中作标记,这样当异常出现时就可以回到这里,try子句先执行,接下来会发生什么依赖于执行时是否出现异常。

    • 如果当try后的语句执行时发生异常,python就跳回到try并执行第一个匹配该异常的except子句,异常处理完毕,控制流就通过整个try语句(除非在处理异常时又引发新的异常)。
    • 如果在try后的语句里发生了异常,却没有匹配的except子句,异常将被递交到上层的try,或者到程序的最上层(这样将结束程序,并打印缺省的出错信息)。
    • 如果在try子句执行时没有发生异常,python将执行else语句后的语句(如果有else的话),然后控制流通过整个try语句。

    实例

    下面是简单的例子,它打开一个文件,在该文件中的内容写入内容,且并未发生异常:

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    try:
        fh = open("testfile", "w")
        fh.write("这是一个测试文件,用于测试异常!!")
    except IOError:
        print "Error: 没有找到文件或读取文件失败"
    else:
        print "内容写入文件成功"
        fh.close()

    以上程序输出结果:

    $ python test.py 
    内容写入文件成功
    $ cat testfile       # 查看写入的内容
    这是一个测试文件,用于测试异常!!

    实例

    下面是简单的例子,它打开一个文件,在该文件中的内容写入内容,但文件没有写入权限,发生了异常:

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    try:
        fh = open("testfile", "w")
        fh.write("这是一个测试文件,用于测试异常!!")
    except IOError:
        print "Error: 没有找到文件或读取文件失败"
    else:
        print "内容写入文件成功"
        fh.close()

    在执行代码前为了测试方便,我们可以先去掉 testfile 文件的写权限,命令如下:

    chmod -w testfile

    再执行以上代码:

    $ python test.py 
    Error: 没有找到文件或读取文件失败

    使用except而不带任何异常类型

     

    你可以不带任何异常类型使用except,如下实例:

    try:
        正常的操作
       ......................
    except:
        发生异常,执行这块代码
       ......................
    else:
        如果没有异常执行这块代码

    以上方式try-except语句捕获所有发生的异常。但这不是一个很好的方式,我们不能通过该程序识别出具体的异常信息。因为它捕获所有的异常。


    使用except而带多种异常类型

    你也可以使用相同的except语句来处理多个异常信息,如下所示:

    try:
        正常的操作
       ......................
    except(Exception1[, Exception2[,...ExceptionN]]]):
       发生以上多个异常中的一个,执行这块代码
       ......................
    else:
        如果没有异常执行这块代码

    try-finally 语句

    try-finally 语句无论是否发生异常都将执行最后的代码。

    try:
    <语句>
    finally:
    <语句>    #退出try时总会执行
    raise

    实例

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    try:
        fh = open("testfile", "w")
        fh.write("这是一个测试文件,用于测试异常!!")
    finally:
        print "Error: 没有找到文件或读取文件失败"

    如果打开的文件没有可写权限,输出如下所示:

    $ python test.py 
    Error: 没有找到文件或读取文件失败

    同样的例子也可以写成如下方式:

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    try:
        fh = open("testfile", "w")
        try:
            fh.write("这是一个测试文件,用于测试异常!!")
        finally:
            print "关闭文件"
            fh.close()
    except IOError:
        print "Error: 没有找到文件或读取文件失败"

    当在try块中抛出一个异常,立即执行finally块代码。

    finally块中的所有语句执行后,异常被再次触发,并执行except块代码。

    参数的内容不同于异常。


    异常的参数

    一个异常可以带上参数,可作为输出的异常信息参数。

    你可以通过except语句来捕获异常的参数,如下所示:

    try:
        正常的操作
       ......................
    except ExceptionType, Argument:
        你可以在这输出 Argument 的值...

    变量接收的异常值通常包含在异常的语句中。在元组的表单中变量可以接收一个或者多个值。

    元组通常包含错误字符串,错误数字,错误位置。

    实例

    以下为单个异常的实例:

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    # 定义函数
    def temp_convert(var):
        try:
            return int(var)
        except ValueError, Argument:
            print "参数没有包含数字\n", Argument
    
    # 调用函数
    temp_convert("xyz");

    以上程序执行结果如下:

    $ python test.py 
    参数没有包含数字
    invalid literal for int() with base 10: 'xyz'

    触发异常

    我们可以使用raise语句自己触发异常

    raise语法格式如下:

    raise [Exception [, args [, traceback]]]

    语句中 Exception 是异常的类型(例如,NameError)参数标准异常中任一种,args 是自已提供的异常参数。

    最后一个参数是可选的(在实践中很少使用),如果存在,是跟踪异常对象。

    实例

    一个异常可以是一个字符串,类或对象。 Python的内核提供的异常,大多数都是实例化的类,这是一个类的实例的参数。

    定义一个异常非常简单,如下所示:

    def functionName( level ):
        if level < 1:
            raise Exception("Invalid level!", level)
            # 触发异常后,后面的代码就不会再执行

    注意:为了能够捕获异常,"except"语句必须有用相同的异常来抛出类对象或者字符串。

    例如我们捕获以上异常,"except"语句如下所示:

    try:
        正常逻辑
    except Exception,err:
        触发自定义异常    
    else:
        其余代码

    实例

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    # 定义函数
    def mye( level ):
        if level < 1:
            raise Exception,"Invalid level!"
            # 触发异常后,后面的代码就不会再执行
    try:
        mye(0)            # 触发异常
    except Exception,err:
        print 1,err
    else:
        print 2

    执行以上代码,输出结果为:

    $ python test.py 
    1 Invalid level!

    用户自定义异常

    通过创建一个新的异常类,程序可以命名它们自己的异常。异常应该是典型的继承自Exception类,通过直接或间接的方式。

    以下为与RuntimeError相关的实例,实例中创建了一个类,基类为RuntimeError,用于在异常触发时输出更多的信息。

    在try语句块中,用户自定义的异常后执行except块语句,变量 e 是用于创建Networkerror类的实例。

    class Networkerror(RuntimeError):
        def __init__(self, arg):
            self.args = arg

    在你定义以上类后,你可以触发该异常,如下所示:

    try:
        raise Networkerror("Bad hostname")
    except Networkerror,e:
        print e.args

     Python File 方法

    Python OS 文件/目录方法 

     

    2 篇笔记

    1.    ljm

        131***1561@qq.com

      0 作为除数:

      #!/usr/bin/python
      # -*- coding: UTF-8 -*-
      
      try:
          1 / 0
      except Exception as e:
          '''异常的父类,可以捕获所有的异常'''
          print "0不能被除"
      else:
          '''保护不抛出异常的代码'''
          print "没有异常"
      finally:
          print "最后总是要执行我"
      ljm

         ljm

        131***1561@qq.com

      1年前 (2017-06-27)
    2.    Tom

        jie***en@sjtu.edu.cn

      异常处理代码执行说明:

      #!/usr/bin/python
      # -*- coding: UTF-8 -*-
      
      #This is note foe exception
      
      try:
        code    #需要判断是否会抛出异常的代码,如果没有异常处理,python会直接停止执行程序
      
      except:  #这里会捕捉到上面代码中的异常,并根据异常抛出异常处理信息
      #except ExceptionName,args:    #同时也可以接受异常名称和参数,针对不同形式的异常做处理
      
        code  #这里执行异常处理的相关代码,打印输出等
      
      
      else:  #如果没有异常则执行else
      
        code  #try部分被正常执行后执行的代码
      
      finally:
        code  #退出try语句块总会执行的程序
      
      
      
      #函数中做异常检测
      def try_exception(num):
        try:
          return int(num)
        except ValueError,arg:
          print arg,"is not a number"
        else:
          print "this is a number inputs"
      
      
      try_exception('xxx')
      
      #输出异常值
      Invalide literal for int() with base 10: 'xxx' is not a number
    展开全文
  • Python2 异常处理

    千次阅读 2019-01-28 09:36:30
    Python 异常处理 python提供了两个非常重要的功能来处理python程序在运行中出现的异常和错误。你可以使用该功能来调试python程序异常处理 断言(Assertions) python标准异常: 异常名称 描述 ...

    Python 异常处理

    python提供了两个非常重要的功能来处理python程序在运行中出现的异常和错误。你可以使用该功能来调试python程序。

    1. 异常处理
    2. 断言(Assertions)

    python标准异常:

    异常名称 描述
    BaseException 所有异常的基类
    SystemExit 解释器请求退出
    KeyboardInterrupt 用户中断执行(通常是输入^C)
    Exception 常规错误的基类
    StopIteration 迭代器没有更多的值
    GeneratorExit 生成器(generator)发生异常来通知退出
    StandardError 所有的内建标准异常的基类
    ArithmeticError 所有数值计算错误的基类
    FloatingPointError 浮点计算错误
    OverflowError 数值运算超出最大限制
    ZeroDivisionError 除(或取模)零 (所有数据类型)
    AssertionError 断言语句失败
    AttributeError 对象没有这个属性
    EOFError 没有内建输入,到达EOF 标记
    EnvironmentError 操作系统错误的基类
    IOError 输入/输出操作失败
    OSError 操作系统错误
    WindowsError 系统调用失败
    ImportError 导入模块/对象失败
    LookupError 无效数据查询的基类
    IndexError 序列中没有此索引(index)
    KeyError 映射中没有这个键
    MemoryError 内存溢出错误(对于Python 解释器不是致命的)
    NameError 未声明/初始化对象 (没有属性)
    UnboundLocalError 访问未初始化的本地变量
    ReferenceError 弱引用(Weak reference)试图访问已经垃圾回收了的对象
    RuntimeError 一般的运行时错误
    NotImplementedError 尚未实现的方法
    SyntaxError Python 语法错误
    IndentationError 缩进错误
    TabError Tab 和空格混用
    SystemError 一般的解释器系统错误
    TypeError 对类型无效的操作
    ValueError 传入无效的参数
    UnicodeError Unicode 相关的错误
    UnicodeDecodeError Unicode 解码时的错误
    UnicodeEncodeError Unicode 编码时错误
    UnicodeTranslateError Unicode 转换时错误
    Warning 警告的基类
    DeprecationWarning 关于被弃用的特征的警告
    FutureWarning 关于构造将来语义会有改变的警告
    OverflowWarning 旧的关于自动提升为长整型(long)的警告
    PendingDeprecationWarning 关于特性将会被废弃的警告
    RuntimeWarning 可疑的运行时行为(runtime behavior)的警告
    SyntaxWarning 可疑的语法的警告
    UserWarning 用户代码生成的警告

    什么是异常?

    异常即是一个事件,该事件会在程序执行过程中发生,影响了程序的正常执行。

    一般情况下,在Python无法正常处理程序时就会发生一个异常。

    异常是Python对象,表示一个错误。

    当Python脚本发生异常时我们需要捕获处理它,否则程序会终止执行。

    异常处理

    捕捉异常可以使用try/except语句。

    try/except语句用来检测try语句块中的错误,从而让except语句捕获异常信息并处理。

    如果你不想在异常发生时结束你的程序,只需在try里捕获它。

    语法:

    以下为简单的try…except…else的语法:

    try:
    <语句>        #运行别的代码
    except <名字><语句>        #如果在try部份引发了'name'异常
    except <名字><数据>:
    <语句>        #如果引发了'name'异常,获得附加的数据
    else:
    <语句>        #如果没有异常发生
    

    try的工作原理是,当开始一个try语句后,python就在当前程序的上下文中作标记,这样当异常出现时就可以回到这里,try子句先执行,接下来会发生什么依赖于执行时是否出现异常。

    如果当try后的语句执行时发生异常,python就跳回到try并执行第一个匹配该异常的except子句,异常处理完毕,控制流就通过整个try语句(除非在处理异常时又引发新的异常)。
    如果在try后的语句里发生了异常,却没有匹配的except子句,异常将被递交到上层的try,或者到程序的最上层(这样将结束程序,并打印缺省的出错信息)。
    如果在try子句执行时没有发生异常,python将执行else语句后的语句(如果有else的话),然后控制流通过整个try语句。
    实例
    下面是简单的例子,它打开一个文件,在该文件中的内容写入内容,且并未发生异常:

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    try:
        fh = open("testfile", "w")
        fh.write("这是一个测试文件,用于测试异常!!")
    except IOError:
        print "Error: 没有找到文件或读取文件失败"
    else:
        print "内容写入文件成功"
        fh.close()
    

    以上程序输出结果:

    $ python test.py 
    内容写入文件成功
    $ cat testfile       # 查看写入的内容
    这是一个测试文件,用于测试异常!!
    

    实例
    下面是简单的例子,它打开一个文件,在该文件中的内容写入内容,但文件没有写入权限,发生了异常:

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    try:
        fh = open("testfile", "w")
        fh.write("这是一个测试文件,用于测试异常!!")
    except IOError:
        print "Error: 没有找到文件或读取文件失败"
    else:
        print "内容写入文件成功"
        fh.close()
    

    在执行代码前为了测试方便,我们可以先去掉 testfile 文件的写权限,命令如下:

    chmod -w testfile
    

    再执行以上代码:

    $ python test.py 
    Error: 没有找到文件或读取文件失败
    

    使用except而不带任何异常类型
    你可以不带任何异常类型使用except,如下实例:

    try:
        正常的操作
       ......................
    except:
        发生异常,执行这块代码
       ......................
    else:
        如果没有异常执行这块代码
    

    以上方式try-except语句捕获所有发生的异常。但这不是一个很好的方式,我们不能通过该程序识别出具体的异常信息。因为它捕获所有的异常。

    使用except而带多种异常类型
    你也可以使用相同的except语句来处理多个异常信息,如下所示:

    try:
        正常的操作
       ......................
    except(Exception1[, Exception2[,...ExceptionN]]]):
       发生以上多个异常中的一个,执行这块代码
       ......................
    else:
        如果没有异常执行这块代码
    

    try-finally 语句
    try-finally 语句无论是否发生异常都将执行最后的代码。

    try:
    <语句>
    finally:
    <语句>    #退出try时总会执行
    raise
    

    实例

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    try:
        fh = open("testfile", "w")
        fh.write("这是一个测试文件,用于测试异常!!")
    finally:
        print "Error: 没有找到文件或读取文件失败"
    

    如果打开的文件没有可写权限,输出如下所示:

    $ python test.py 
    Error: 没有找到文件或读取文件失败
    

    同样的例子也可以写成如下方式:

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    try:
        fh = open("testfile", "w")
        try:
            fh.write("这是一个测试文件,用于测试异常!!")
        finally:
            print "关闭文件"
            fh.close()
    except IOError:
        print "Error: 没有找到文件或读取文件失败"
    

    当在try块中抛出一个异常,立即执行finally块代码。

    finally块中的所有语句执行后,异常被再次触发,并执行except块代码。

    参数的内容不同于异常。

    异常的参数

    一个异常可以带上参数,可作为输出的异常信息参数。

    你可以通过except语句来捕获异常的参数,如下所示:

    try:
        正常的操作
       ......................
    except ExceptionType, Argument:
        你可以在这输出 Argument 的值...
    

    变量接收的异常值通常包含在异常的语句中。在元组的表单中变量可以接收一个或者多个值。

    元组通常包含错误字符串,错误数字,错误位置。

    实例
    以下为单个异常的实例:

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    # 定义函数
    def temp_convert(var):
        try:
            return int(var)
        except ValueError, Argument:
            print "参数没有包含数字\n", Argument
    
    # 调用函数
    temp_convert("xyz");
    

    以上程序执行结果如下:

    $ python test.py 
    参数没有包含数字
    invalid literal for int() with base 10: 'xyz'
    

    触发异常

    我们可以使用raise语句自己触发异常

    raise语法格式如下:

    raise [Exception [, args [, traceback]]]
    

    语句中 Exception 是异常的类型(例如,NameError)参数标准异常中任一种,args 是自已提供的异常参数。

    最后一个参数是可选的(在实践中很少使用),如果存在,是跟踪异常对象。

    实例
    一个异常可以是一个字符串,类或对象。 Python的内核提供的异常,大多数都是实例化的类,这是一个类的实例的参数。

    定义一个异常非常简单,如下所示:

    def functionName( level ):
        if level < 1:
            raise Exception("Invalid level!", level)
            # 触发异常后,后面的代码就不会再执行
    

    注意:为了能够捕获异常,"except"语句必须有用相同的异常来抛出类对象或者字符串。

    例如我们捕获以上异常,"except"语句如下所示:

    try:
        正常逻辑
    except Exception,err:
        触发自定义异常    
    else:
        其余代码
    

    实例

    #!/usr/bin/python
    # -*- coding: UTF-8 -*-
    
    # 定义函数
    def mye( level ):
        if level < 1:
            raise Exception,"Invalid level!"
            # 触发异常后,后面的代码就不会再执行
    try:
        mye(0)            # 触发异常
    except Exception,err:
        print 1,err
    else:
        print 2
    

    执行以上代码,输出结果为:

    $ python test.py 
    1 Invalid level!
    

    用户自定义异常

    通过创建一个新的异常类,程序可以命名它们自己的异常。异常应该是典型的继承自Exception类,通过直接或间接的方式。

    以下为与RuntimeError相关的实例,实例中创建了一个类,基类为RuntimeError,用于在异常触发时输出更多的信息。

    在try语句块中,用户自定义的异常后执行except块语句,变量 e 是用于创建Networkerror类的实例。

    class Networkerror(RuntimeError):
        def __init__(self, arg):
            self.args = arg
    

    在你定义以上类后,你可以触发该异常,如下所示:

    try:
        raise Networkerror("Bad hostname")
    except Networkerror,e:
        print e.args
    
    展开全文
  • python教程 异常处理

    2019-03-09 15:38:59
    python的异常与异常处理一、什么是异常1、try/except方式2、try-except-finally方式3、多重except捕获异常二、python内置的异常类三、raise语句 一、什么是异常 由于代码bug引起程序的崩溃就视为异常情况,例如:除...

    一、什么是异常

    由于代码bug引起程序的崩溃就视为异常情况,例如:除零运算、参数类型不对等等。

    异常处理有三种方式:

    1、try/except方式

    使用try/except来处理异常,使用方式如下,当发生异常时执行except后面的语句

    try:
    
        a = input("请输入被除数:")
    
        b = input("请输入除数:")
    
        print(int(a)/int(b))
    
    except:
    
        print("除数不能为零")
    

    2、try-except-finally方式

    这种方式无论是否发生异常,都执行finally后面的语句,使用方式如下:

    try:
    
        a = input("请输入被除数:")
    
        b = input("请输入除数:")
    
        print(int(a)/int(b))
    
    except:
    
        print("除数不能为零")
    
    finally:
    
        print("计算完成")
    

    3、多重except捕获异常

    通过except捕获多种不同类型的异常:

    try:
    
        a = input("请输入被除数:")
    
        b = input("请输入除数:")
    
        print(int(a)/int(b))
    
    except ValueError:
    
        print("请输入数字类型")
    
    except ZeroDivisionError:
    
        print("除数不能为零")
    
    except BaseException:
    
        print("其他异常,请检查")
    
    finally:
    
        print("计算完成")
    

    在这段代码中,ValueError、ZeroDivisionError、BaseException是python事先定义好的异常类。

    二、python内置的异常类

    在这里插入图片描述

    三、raise语句

    raise语句,主动抛出异常

    a = int(input("请输入被除数:"))
    
    b = int(input("请输入除数:"))
    
    if b == 0:
    
        print("除零异常")
    
        raise ZeroDivisionError
    
    print(a/b)
    

    我们接着来认识一下python中的迭代器
    欢迎收看:如何自学人工智能

    展开全文
  • python异常处理

    万次阅读 2020-07-13 04:20:08
    try方法实现python异常处理
  • Python异常处理

    2017-11-04 16:45:31
    Python异常处理
  • Python异常处理机制

    2016-08-29 10:34:09
    当你的程序中出现异常情况时就需要异常处理。比如当你打开一个不存在的文件时。当你的程序中有一些无效的语句时,Python会提示你有错误存在。 下面是一个拼写错误的例子,print写成了Print。Python是大小写敏感的,...
  • Python Exception 异常处理

    千次阅读 2017-09-08 10:36:12
    1-异常处理基本要求是:捕捉异常,同时记录异常到log,同时输出到本地,并根据异常返回提示信息到前端,基本处理流程是 import logging import json import traceback # 实现日志记录和输出 logger = logging....
  • Python异常处理机制

    千次阅读 2017-02-28 21:43:21
    Python 异常处理 python提供了两个非常重要的功能来处理python程序在运行中出现的异常和错误。你可以使用该功能来调试python程序异常处理 断言(Assertions) python标准异常 异常名称 描述 ...
  • Python 异常处理

    2015-09-01 22:38:01
    由此可以使用两功能来调试python程序异常处理 断言-assert 1、异常处理1.1、异常概念异常是指程序中的例外,违例,影响程序正常执行的情况。异常机制是指程序出现错误后,程序的处理方法。当出现错误后,程序的 ...
  • python Exception 异常处理

    千次阅读 2013-05-29 15:36:07
    如果异常对象没有被捕获或者处理程序就会用回溯(Tracback,一种错误信息)终止执行。 我们知道异常信息可以提示出错的信息,所有的异常都是基类Exception的子类,自定义异常可以从Exception类中继承。 ...
  • try,except,else,finall1、正常执行 try 正常执行,执行 else ,正常执行,执行 finall;2、异常抛出 try 异常执行,执行except , 执行之后,执行finall;...
  • Python异常处理

    千次阅读 2015-04-30 11:34:08
    一、什么是异常? 异常即是一个事件,该事件会在程序执行过程中发生,影响了程序的正常执行。...二、异常处理 捕捉异常可以使用try/except语句。 try/except语句用来检测try语句块中的错误,从而让ex
  • 第十六天学Python异常处理

    千次阅读 2020-05-02 16:54:22
    Python异常处理
  • Python异常处理

    2015-08-13 20:28:34
    当你的程序中出现异常情况时就需要异常处理。比如当你打开一个不存在的文件时。当你的程序中有一些无效的语句时,Python会提示你有错误存在。 下面是一个拼写错误的例子,print写成了Print。Python是大小写敏感的,...
  • Python-程序异常处理

    2019-04-11 20:39:27
    一般情况下,在Python无法正常处理程序时就会发生一个异常异常Python对象,表示一个错误。当Python脚本发生异常时我们需要捕获处理它,否则程序会终止执行。 举个例子: num = eval(input("please input a ...
  • Python异常处理方法总结

    万次阅读 多人点赞 2018-08-12 00:32:48
    调试Python程序时,经常会报出一些异常异常的原因一方面可能是写程序时由于疏忽或者考虑不全造成了错误,这时就需要根据异常Traceback到出错点,进行分析改正;另一方面,有些异常是不可避免的,但我们可以对异常...
  • python函数异常处理

    千次阅读 2018-09-20 14:50:36
    2.程序开发的时候,很难将所有的特殊情况都处理,通过异常捕获可以针对突发时间做集中处理,从而保证程序的健壮性和稳定性 3.程序开发中,对某些代码的执行不能确定(程序语法完全正确),预先判断不到的,可以增加...
  • 2.2 Python异常处理

    万次阅读 2019-05-21 10:38:50
    2.2 Python异常处理 2.2.1 异常介绍: 即便Python程序的语法是正确的,在运行它的时候,也有可能发生错误。运行期检测到的错误被称为异常。 大多数的异常都不会被程序处理,都以错误信息的形式展现在这里: &...
  • python NoSuchElementException异常处理

    千次阅读 2019-07-19 00:55:00
    python爬虫程序,用Selenium模拟点击时报出异常NoSuchElementException:Unable to locate...... 出错原因:https://www.cnblogs.com/cttcarrotsgarden/p/11210883.html 异常通常发生于找不到目标元素的时候 导入...
  • python 超时异常处理

    2015-07-23 21:38:00
    异常处理具体见:【循序渐进学Python】9.异常处理 环境平台:Python2.7.9 + Win8.1 本篇记录一下自己写爬虫的遇到的问题,程序中批量获取图片地址,然后批量保存。由于没有设置网址打开超时,导致程序一直卡在哪里...
  • 3、Python中的异常处理 (1)异常处理之try…except…结构 (2)异常处理之try…except…finally…结构 (3)异常处理之try…except… else… finally…结构 4、抛出异常 编写和运行程序时,不可避免地会产生...
  • [Python]异常处理技术(二)

    千次阅读 2014-03-28 18:00:14
    [Python]异常处理技术(二) 重复引起异常 Re-raising Exceptions 有的时候清除工作需要对错误处理和正确处理是不同的。例如,数据库操作错误需要回滚事务,但是没有错误需要commit操作。这种情况下,你必须要捕获...
  • Python 2 异常处理 (try 和 except)

    千次阅读 2017-12-06 23:37:35
    异常处理使程序能检测错误,处理它们,然后继续运行。当试图用一个数除以零时,就会发生 ZeroDivisionError。 1. example 1 #!/usr/bin/env python # -*- coding: utf-8 -*- from __future__ import absolute_...
  • Python异常处理和函数

    千次阅读 2018-07-04 21:18:03
    Python异常处理什么是异常?异常即是一个事件,该事件会在程序执行过程中发生,影响了程序的正常执行。一般情况下,在Python无法正常处理程序时就会发生一个异常。异常是Python对象,表示一个错误。当Python脚本发生...

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 129,229
精华内容 51,691
关键字:

python程序异常处理

python 订阅